Subject: cgoban: ftbfs with GCC-15

From: Matthias Klose <[email-masked]>
Date: Mon, 17 Feb 2025 17:06:55 +0000

Package: src:cgoban
Version: 1.9.14-20
Severity: important
Tags: sid forky
User: [email-masked]
Usertags: ftbfs-gcc-15

[This bug is NOT targeted to the upcoming trixie release]

Please keep this issue open in the bug tracker for the package it
was filed for.  If a fix in another package is required, please
file a bug for the other package (or clone), and add a block in this
package. Please keep the issue open until the package can be built in
a follow-up test rebuild.

The package fails to build in a test rebuild on at least amd64 with
gcc-15/g++-15, but succeeds to build with gcc-14/g++-14. The
severity of this report will be raised before the forky release.

The full build log can be found at:
http://qa-logs.debian.net/2025/02/16/amd64exp/cgoban_1.9.14-20_unstable_gccexp.log.gz
The last lines of the build log are at the end of this report.

To build with GCC 15, either set CC=gcc-15 CXX=g++-15 explicitly,
or install the gcc, g++, gfortran, ... packages from experimental.

  apt-get -t=experimental install g++ 

GCC 15 now defaults to the C23/C++23 standards, exposing many FTBFS.
Other Common build failures are new warnings resulting in build failures
with -Werror turned on, or new/dropped symbols in Debian symbols files.
For other C/C++ related build failures see the porting guide at
http://gcc.gnu.org/gcc-15/porting_to.html

[...]
gcc -DHAVE_CONFIG_H -I. -I.. -I ../wmslib/src  -Wdate-time -D_FORTIFY_SOURCE=2  -O2 -fomit-frame-pointer  -c -o goGame.o goGame.c
gcc -DHAVE_CONFIG_H -I. -I.. -I ../wmslib/src  -Wdate-time -D_FORTIFY_SOURCE=2  -O2 -fomit-frame-pointer  -c -o goHash.o goHash.c
gcc -DHAVE_CONFIG_H -I. -I.. -I ../wmslib/src  -Wdate-time -D_FORTIFY_SOURCE=2  -O2 -fomit-frame-pointer  -c -o goPic.o goPic.c
gcc -DHAVE_CONFIG_H -I. -I.. -I ../wmslib/src  -Wdate-time -D_FORTIFY_SOURCE=2  -O2 -fomit-frame-pointer  -c -o goScore.o goScore.c
gcc -DHAVE_CONFIG_H -I. -I.. -I ../wmslib/src  -Wdate-time -D_FORTIFY_SOURCE=2  -O2 -fomit-frame-pointer  -c -o goTime.o goTime.c
gcc -DHAVE_CONFIG_H -I. -I.. -I ../wmslib/src  -Wdate-time -D_FORTIFY_SOURCE=2  -O2 -fomit-frame-pointer  -c -o goban.o goban.c
gcc -DHAVE_CONFIG_H -I. -I.. -I ../wmslib/src  -Wdate-time -D_FORTIFY_SOURCE=2  -O2 -fomit-frame-pointer  -c -o help.o help.c
gcc -DHAVE_CONFIG_H -I. -I.. -I ../wmslib/src  -Wdate-time -D_FORTIFY_SOURCE=2  -O2 -fomit-frame-pointer  -c -o local.o local.c
gcc -DHAVE_CONFIG_H -I. -I.. -I ../wmslib/src  -Wdate-time -D_FORTIFY_SOURCE=2  -O2 -fomit-frame-pointer  -c -o main.o main.c
gcc -DHAVE_CONFIG_H -I. -I.. -I ../wmslib/src  -Wdate-time -D_FORTIFY_SOURCE=2  -O2 -fomit-frame-pointer  -c -o msg.o msg.c
gcc -DHAVE_CONFIG_H -I. -I.. -I ../wmslib/src  -Wdate-time -D_FORTIFY_SOURCE=2  -O2 -fomit-frame-pointer  -c -o plasma.o plasma.c
gcc -DHAVE_CONFIG_H -I. -I.. -I ../wmslib/src  -Wdate-time -D_FORTIFY_SOURCE=2  -O2 -fomit-frame-pointer  -c -o setup.o setup.c
gcc -DHAVE_CONFIG_H -I. -I.. -I ../wmslib/src  -Wdate-time -D_FORTIFY_SOURCE=2  -O2 -fomit-frame-pointer  -c -o sgf.o sgf.c
main.c: In function ‘main’:
main.c:59:19: error: passing argument 2 of ‘signal’ from incompatible pointer type [-Wincompatible-pointer-types]
   59 |   signal(SIGTERM, sigHandler);  /* Catch these signals gracefully. */
      |                   ^~~~~~~~~~
      |                   |
      |                   void (*)(void)
In file included from ../wmslib/src/wms.h:21,
                 from main.c:11:
/usr/include/signal.h:88:57: note: expected ‘__sighandler_t’ {aka ‘void (*)(int)’} but argument is of type ‘void (*)(void)’
   88 | extern __sighandler_t signal (int __sig, __sighandler_t __handler)
      |                                          ~~~~~~~~~~~~~~~^~~~~~~~~
main.c:32:20: note: ‘sigHandler’ declared here
   32 | static RETSIGTYPE  sigHandler();
      |                    ^~~~~~~~~~
/usr/include/signal.h:72:16: note: ‘__sighandler_t’ declared here
   72 | typedef void (*__sighandler_t) (int);
      |                ^~~~~~~~~~~~~~
main.c:60:18: error: passing argument 2 of ‘signal’ from incompatible pointer type [-Wincompatible-pointer-types]
   60 |   signal(SIGINT, sigHandler);
      |                  ^~~~~~~~~~
      |                  |
      |                  void (*)(void)
/usr/include/signal.h:88:57: note: expected ‘__sighandler_t’ {aka ‘void (*)(int)’} but argument is of type ‘void (*)(void)’
   88 | extern __sighandler_t signal (int __sig, __sighandler_t __handler)
      |                                          ~~~~~~~~~~~~~~~^~~~~~~~~
main.c:32:20: note: ‘sigHandler’ declared here
   32 | static RETSIGTYPE  sigHandler();
      |                    ^~~~~~~~~~
/usr/include/signal.h:72:16: note: ‘__sighandler_t’ declared here
   72 | typedef void (*__sighandler_t) (int);
      |                ^~~~~~~~~~~~~~
main.c:61:18: error: passing argument 2 of ‘signal’ from incompatible pointer type [-Wincompatible-pointer-types]
   61 |   signal(SIGHUP, sigHandler);
      |                  ^~~~~~~~~~
      |                  |
      |                  void (*)(void)
/usr/include/signal.h:88:57: note: expected ‘__sighandler_t’ {aka ‘void (*)(int)’} but argument is of type ‘void (*)(void)’
   88 | extern __sighandler_t signal (int __sig, __sighandler_t __handler)
      |                                          ~~~~~~~~~~~~~~~^~~~~~~~~
main.c:32:20: note: ‘sigHandler’ declared here
   32 | static RETSIGTYPE  sigHandler();
      |                    ^~~~~~~~~~
/usr/include/signal.h:72:16: note: ‘__sighandler_t’ declared here
   72 | typedef void (*__sighandler_t) (int);
      |                ^~~~~~~~~~~~~~
make[4]: *** [Makefile:529: main.o] Error 1
make[4]: *** Waiting for unfinished jobs....
make[4]: Leaving directory '/build/reproducible-path/cgoban-1.9.14/src'
make[3]: *** [Makefile:545: all-recursive] Error 1
make[3]: Leaving directory '/build/reproducible-path/cgoban-1.9.14/src'
make[2]: *** [Makefile:444: all-recursive] Error 1
make[2]: Leaving directory '/build/reproducible-path/cgoban-1.9.14'
make[1]: *** [Makefile:346: all] Error 2
make[1]: Leaving directory '/build/reproducible-path/cgoban-1.9.14'
dh_auto_build: error: make -j8 returned exit code 2
make: *** [debian/rules:4: binary] Error 25
dpkg-buildpackage: error: debian/rules binary subprocess returned exit status 2